#include "precompile.h"

#include <math.h>
#include <float.h>

#include "buff/beatback.h"
#include "creature.h"

#include "mt/Buff.h"

void BeatBackBuff::Activate()
{
    if (caster_.Get()) {
        if (std::abs(caster_.Get()->GetAttackDir().x) > FLT_EPSILON ||
            std::abs(caster_.Get()->GetAttackDir().y) > FLT_EPSILON) {
            float distance = meta->GetBuffParam1(this);
            if (std::abs(distance) > 0) {
                glm::vec3 old_move_dir = owner->GetMoveDir();
                owner->SetMoveDir(caster_.Get()->GetAttackDir());
                owner->ForwardMove(distance, kNormalReason);
                owner->SetMoveDir(old_move_dir);
            }
        }
    }
}

void BeatBackBuff::Deactivate()
{

}
