#pragma once

#include <bitset>

namespace mtb
{

  class BattlePotion
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int durationType() const { return durationType_; };
    const std::string effect() const { return effect_; };
    int cooldown() const { return cooldown_; };
    int duration() const { return duration_; };
    int potionId() const { return potionId_; };
    int buff() const { return buff_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_durationType() const { return __flags__.test(1);};
    bool has_effect() const { return __flags__.test(2);};
    bool has_cooldown() const { return __flags__.test(3);};
    bool has_duration() const { return __flags__.test(4);};
    bool has_potionId() const { return __flags__.test(5);};
    bool has_buff() const { return __flags__.test(6);};

  protected:

    int id_ = 0;
    int durationType_ = 0;
    std::string effect_;
    int cooldown_ = 0;
    int duration_ = 0;
    int potionId_ = 0;
    int buff_ = 0;

public:
    std::bitset<7> __flags__;
  };

};
